;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; XPLAN
;
; XPLAN richtet das BKS und die aktuelle Ansicht nach einem zu whlenden
; Objekt aus. Dieses ist eine Verknpfung der AutoCAD-Befehle BKS
; (BKS ausrichten) und DRSICHT (Ansicht ausrichten). Das Tool verhindert
; aber, da der Befehl DRSICHT die gesamte Zeichnung auf ihre Grenzen zoomt,
; sondern stellt den vorherigen Zoomausschnitt wieder her.
;
; Sehr praktisches Tool, wenn man fters in Zeichnungen die Ansicht
; schnell nach einem Objekt ausrichten mchte.
;
; Aufruf: xplan
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; (c) Dipl.-Ing.  Volker Kleppel
; http://www.cadwerk.com
; vkleppel@gmx.de
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; Version: 2.1                      Datum: 20.05.2018
; AutoCAD12   [ ]  AutoCAD14   [x]  AutoCAD2000(i) [x]   
; AutoCAD2002 [x]  AutoCAD2004 [x]  AutoCAD2005    [x]
; AutoCAD2006 [x]  AutoCAD2007 [x]  AutoCAD2008    [x]
; AutoCAD2009 [x]  AutoCAD2010 [x]  AutoCAD2011    [x]
; AutoCAD2012 [x]  AutoCAD2013 [x]  AutoCAD2014    [x]
; AutoCAD2015 [x]  AutoCAD2016 [x]  AutoCAD2017    [x]
; AutoCAD2018 [x]  AutoCAD2019 [x]
; Freeware    [x]  Shareware   [ ]
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

(defun c:xplan ( / dump vctr vsize ssize ucsx windowX windowY ratio p)

	;Systemvariablen
		(setq sys1 (getvar "CMDECHO"))
		(setq vctr (trans (getvar "viewctr") 1 0))
		(setq vsize (getvar "viewsize"))
		(setq ssize (getvar "screensize"))
		(setq ucsx (getvar "ucsXdir"))
		(setq xperror *error*)
		(setq *error* xplan_error)

	;Berechnungen
		(setq ratio (/ (car ssize) (cadr ssize)))
		(setq windowX (* vsize ratio))
		(setq windowY vsize)

	;Ausfhrung
		(if (= (boole 1 1 (getvar "viewmode")) 0)
			(progn
				(initget 128 "Welt Objekt")
				(setq answer (getkword "\nBKS ausrichten nach: Welt/<Objekt> "))
				(if (or (= answer nil) (= answer "Objekt"))
				(command "_ucs" "_object" pause)
				(command "_ucs" "")
				)

				(if (equal ucsx (getvar "ucsXdir"))
					(progn
						(princ "\nDas gewhlte Objekt hat kein gltiges UCS")
					)
					(progn
						(initget 128 "Ja Nein")
						(if (= (setq answer (getkword "\nSoll der Plan nach dem gegenwrtigen UCS ausgerichtet werden? Nein/<Ja> ")) nil) (setq answer "Ja"))
						(if (= answer "Ja")
							(progn
								(command "_plan" "")
								(setq dump (getvar "osmode"))
								(setq p (trans vctr 0 1))
								(setvar "osmode" 0)
								(command "_zoom" "_window" (list (- (car p) (* windowX 0.5)) (- (cadr p) (* windowY 0.5))) (list (+ (car p) (* windowX 0.5)) (+ (cadr p) (* windowY 0.5))))
								(setvar "osmode" dump)
							)
						)
					)
				)	
			)
			(progn
				(princ "\nXPLAN kann nicht innerhalb von Perspektiven angewendet werden")
			)
		)
	(print)
)
(defun xplan_error ()
	(setq *error* xperror)
	(setq xperror nil)
	(princ "\nDas Element besitzt kein gltiges UCS oder das UCS ist bereits danach ausgerichtet")
	(print)
)

(princ "\nXPlan - (c) Dipl.-Ing. V. Kleppel, www.cadwerk.com")
(princ "\nAufruf: xplan")
(print)